feat_s Struct Reference

## Data Fields

int | refcount
| Reference count.
char * | name
| Printable name for this feature type.
int32 | cepsize
| Size of input speech vector (typically, a cepstrum vector).
int32 | n_stream
| Number of feature streams; e.g., 4 in Sphinx-II.
uint32 * | stream_len
| Vector length of each feature stream.
int32 | window_size
| Number of extra frames around given input frame needed to compute corresponding output feature (so total = window_size*2 + 1).
int32 | n_sv
| Number of subvectors.
uint32 * | sv_len
| Vector length of each subvector.
int32 ** | subvecs
| Subvector specification (or NULL for none).
mfcc_t * | sv_buf
| Temporary copy buffer for subvector projection.
int32 | sv_dim
| Total dimensionality of subvector (length of sv_buf).
cmn_type_t | cmn
| Type of CMN to be performed on each utterance.
int32 | varnorm
| Whether variance normalization is to be performed on each utt; Irrelevant if no CMN is performed.
agc_type_t | agc
| Type of AGC to be performed on each utterance.
void(* | compute_feat )(struct feat_s *fcb, mfcc_t **input, mfcc_t **feat)
| Feature computation function.
cmn_t * | cmn_struct
| Structure that stores the temporary variables for cepstral means normalization.
agc_t * | agc_struct
| Structure that stores the temporary variables for acoustic gain control.
mfcc_t ** | cepbuf
| Circular buffer of MFCC frames for live feature computation.
mfcc_t ** | tmpcepbuf
| Array of pointers into cepbuf to handle border cases.
int32 | bufpos
| Write index in cepbuf.
int32 | curpos
| Read index in cepbuf.
mfcc_t *** | lda
| Array of linear transformations (for LDA, MLLT, or whatever).
uint32 | n_lda
| Number of linear transformations in lda.
uint32 | out_dim
| Output dimensionality.

## Detailed Description

Definition at line 116 of file feat.h.

## Field Documentation

## agc

agc_type_t feat_s::agc

Type of AGC to be performed on each utterance.

Definition at line 133 of file feat.h.

## agc_struct

agc_t* feat_s::agc_struct

Structure that stores the temporary variables for acoustic gain control.

Definition at line 150 of file feat.h.

## bufpos

int32 feat_s::bufpos

Write index in cepbuf.

Definition at line 155 of file feat.h.

## cepbuf

mfcc_t** feat_s::cepbuf

Circular buffer of MFCC frames for live feature computation.

Definition at line 153 of file feat.h.

## cepsize

int32 feat_s::cepsize

Size of input speech vector (typically, a cepstrum vector).

Definition at line 119 of file feat.h.

## cmn

cmn_type_t feat_s::cmn

Type of CMN to be performed on each utterance.

Definition at line 130 of file feat.h.

## cmn_struct

cmn_t* feat_s::cmn_struct

Structure that stores the temporary variables for cepstral means normalization.

Definition at line 148 of file feat.h.

## compute_feat

void(* feat_s::compute_feat) (struct feat_s *fcb, mfcc_t **input, mfcc_t **feat)

Feature computation function.

Parameters

  fcb | the feat_t describing this feature type
  input | pointer into the input cepstra
  feat | a 2-d array of output features (n_stream x stream_len)

Returns
  0 if successful, -ve otherwise.

Function for converting window of input speech vector (input[-window_size..window_size]) to output feature vector (feat[stream][]). If NULL, no conversion available, the speech input must be feature vector itself.

Definition at line 147 of file feat.h.

## curpos

int32 feat_s::curpos

Read index in cepbuf.

Definition at line 156 of file feat.h.

## lda

mfcc_t*** feat_s::lda

Array of linear transformations (for LDA, MLLT, or whatever).

Definition at line 158 of file feat.h.

## n_lda

uint32 feat_s::n_lda

Number of linear transformations in lda.

Definition at line 159 of file feat.h.

## n_stream

int32 feat_s::n_stream

Number of feature streams; e.g., 4 in Sphinx-II.

Definition at line 120 of file feat.h.

## n_sv

int32 feat_s::n_sv

Number of subvectors.

Definition at line 124 of file feat.h.

## name

char* feat_s::name

Printable name for this feature type.

Definition at line 118 of file feat.h.

## out_dim

uint32 feat_s::out_dim

Output dimensionality.

Definition at line 160 of file feat.h.

## refcount

int feat_s::refcount

Reference count.

Definition at line 117 of file feat.h.

## stream_len

uint32* feat_s::stream_len

Vector length of each feature stream.

Definition at line 121 of file feat.h.

## subvecs

int32** feat_s::subvecs

Subvector specification (or NULL for none).

Definition at line 126 of file feat.h.

## sv_buf

mfcc_t* feat_s::sv_buf

Temporary copy buffer for subvector projection.

Definition at line 127 of file feat.h.

## sv_dim

int32 feat_s::sv_dim

Total dimensionality of subvector (length of sv_buf).

Definition at line 128 of file feat.h.

## sv_len

uint32* feat_s::sv_len

Vector length of each subvector.

Definition at line 125 of file feat.h.

## tmpcepbuf

mfcc_t** feat_s::tmpcepbuf

Array of pointers into cepbuf to handle border cases.

Definition at line 154 of file feat.h.

## varnorm

int32 feat_s::varnorm

Whether variance normalization is to be performed on each utt; Irrelevant if no CMN is performed.

Definition at line 131 of file feat.h.

## window_size

int32 feat_s::window_size

Number of extra frames around given input frame needed to compute corresponding output feature (so total = window_size*2 + 1).

Definition at line 122 of file feat.h.

The documentation for this struct was generated from the following file:

- include/sphinxbase/feat.h